#pragma warning(disable:4786)
#include <string>
#include <algorithm>
#include <map>
#include <iostream>
#include <functional>

using namespace std;
 
// filename stlmap1.cpp


typedef map<string, string> StringMap;


void ShowFindConstellation(StringMap m, string star) 
{
	cout << star;
	if (m.find(star)==m.end())
	{
		cout << " was not found";
	}
	else
	{
			StringMap::iterator sit = m.find(star);
			cout << " was found in the constellation " << sit->second;
	}
	cout << endl;
}

void ShowFindStars(StringMap m, string constellation) 
{
	cout << constellation << " contains the following stars" << endl;
	StringMap::iterator sit;
	for (sit=m.begin(); sit!=m.end(); sit++)
	{
		if ( constellation == sit->second)
		{
			cout << '\t' << sit->first << endl;
		}
	}
	cout << endl;
}


void main() 
{
	StringMap constellations;

	// Add data to the map
	constellations.insert(StringMap::value_type("Murzim", "Canis Major"));
	constellations.insert(StringMap::value_type("Siruis", "Canis Major"));	
	constellations.insert(StringMap::value_type("Alderberan", "Taurus"));
	constellations.insert(StringMap::value_type("Alnilam", "Orion"));
	constellations.insert(StringMap::value_type("Mintaka", "Orion"));
	constellations.insert(StringMap::value_type("Betelgeuse", "Orion"));
	constellations.insert(StringMap::value_type("Rigel", "Orion"));
	constellations.insert(StringMap::value_type("Alkaid", "Ursa Major"));
	constellations.insert(StringMap::value_type("Alioth", "Ursa Major"));
	constellations.insert(StringMap::value_type("Dubhe", "Ursa Major"));
	
	cout << "Map contains:\n";
	StringMap::iterator sit;
	for (sit=constellations.begin(); sit!=constellations.end(); sit++)
	{
		cout << '\t' << sit->first << " = " << sit->second << endl;
	}
	
	// Find which constellation a star is in
	ShowFindConstellation(constellations, "Alkaid");
	ShowFindConstellation(constellations, "Rigel");
	ShowFindConstellation(constellations, "Pluto");
	cout << endl;

	// Find the stars in a constellation 
	ShowFindStars(constellations, "Orion");
	
}