#include <string>
#include <algorithm>
#include <vector>
#include <iostream>
using namespace std;
 
// filename stlvect1.cpp

void main ()
{
	vector<int> v;  // create an empty vector of integers

	cout << "Size = " << v.size() << endl;
	cout << "Capacity = " << v.capacity() << endl;
	
	int input;
	while (cin >> input)    // while not end of file
	{
		v.push_back (input);  // append to vector
	}

	cout << "Size = " << v.size() << endl;
	cout << "Capacity = " << v.capacity() << endl;

	// sort takes two random iterators, and sorts the elements between
	// them.  As is always the case in STL, this includes the value
	// referred to by first but not the one referred to by last; indeed,
	// this is often the past-the-end value, and is therefore not
	// dereferenceable.
	sort(v.begin(), v.end());

	cout << "Vector contents:" << endl;
	int n = v.size();
	for (int i = 0; i < n; i++)
	{
	  cout << v[i] << "\n";
	}

	cout << "Delete last value from vector" << endl;
	v.pop_back();

	cout << "Size = " << v.size() << endl;
	cout << "Capacity = " << v.capacity() << endl;

	cout << "Access vecor using an iterator" << endl;
	for(vector<int>::iterator vi = v.begin(); vi != v.end(); vi++)
	{
		// Notice deferencing of the iterator using *
		cout << *vi << "\n";
	}

	cout << "First value in vector = " << v.front() << endl;
	cout << "Last value in vector = " << v.back() << endl;


}

